<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>JSDoc: Source: profile/profile-body/profile-body-graphics/Activity.tsx</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>

<body>

<div id="main">

    <h1 class="page-title">Source: profile/profile-body/profile-body-graphics/Activity.tsx</h1>

    



    
    <section>
        <article>
            <pre class="prettyprint source linenums"><code>import React from 'react';
import styled from 'styled-components';
import { ResponsiveContainer, BarChart, Bar, XAxis, YAxis, CartesianGrid, Tooltip, Legend } from 'recharts';
import colors from '../../../../utils/style/colors';
import { IUserDataActivity } from '../../../../utils/interfaces/api.interface';

const Container = styled.div`
  height: 320px;
  background-color: ${colors.background};
  border-radius: 5px;
  position: relative;
  width: 855px;

  .recharts-legend-item-text {
    color: #74798c !important;
    font-size: 14px;
    font-weight: 500;
  }
`;

const ChartTitle = styled.h3`
  margin: 0;
  font-size: 15px;
  font-weight: 500;
  position: absolute;
  top: 25px;
  left: 30px;
`;

const CustomTooltip = styled.div`
  display: flex;
  flex-direction: column;
  gap: 7px;
  background-color: ${colors.secondary};
  padding: 15px 8px;

  p {
    margin: 0;
    text-align: center;
    color: white;
    font-size: 11px;
    font-weight: 500;
  }
`;

/**
 * Renders the acitvity graphic
 * @param   {IUserDataActivity}   activityData   contains user's sessions data
 */
const Activity: React.FC&lt;{ activityData: IUserDataActivity }> = ({ activityData }) => {
  const { sessions } = activityData;

  const dates = sessions.map((elt) => elt.day);

  const kilograms = sessions.map((elt) => elt.kilogram);
  const minKilo = Math.min(...kilograms) - 5;
  const maxKilo = Math.max(...kilograms) + 5;

  const calories = sessions.map((elt) => elt.calories);
  const minCal = Math.min(...calories) - 50;
  const maxCal = Math.max(...calories) + 50;

  const getCustomTooltip = (data: any) => {
    const { payload, active } = data;
    if (active &amp;&amp; payload &amp;&amp; payload.length) {
      return (
        &lt;CustomTooltip>
          &lt;p>{`${payload[0].payload.kilogram}kg`}&lt;/p>
          &lt;p>{`${payload[0].payload.calories}Kcal`}&lt;/p>
        &lt;/CustomTooltip>
      );
    }

    return null;
  };

  // get the correct axis label from index
  const getAxisLabels = (data: any) => {
    let dayIndex = dates.findIndex((day) => day === data.day);
    dayIndex += 1;
    return dayIndex;
  };

  return (
    &lt;Container>
      &lt;ResponsiveContainer width="100%" height={320}>
        &lt;BarChart
          data={activityData.sessions}
          barSize={7}
          barGap={8}
          margin={{
            top: 25,
            right: 25,
            left: 25,
            bottom: 25,
          }}
        >
          &lt;CartesianGrid strokeDasharray="2 2" vertical={false} />
          &lt;XAxis dataKey={getAxisLabels} tickLine={false} dy={15} />
          &lt;YAxis yAxisId="calories" hide domain={[minCal, maxCal]} />
          &lt;YAxis
            yAxisId="kilo"
            orientation="right"
            allowDecimals={false}
            tickLine={false}
            axisLine={false}
            tick={{ fontSize: 14 }}
            domain={[minKilo, maxKilo]}
          />
          &lt;Tooltip content={getCustomTooltip} />
          &lt;Legend verticalAlign="top" align="right" iconType="circle" iconSize={8} height={70} />
          &lt;Bar yAxisId="kilo" name="Poids (kg)" dataKey="kilogram" unit="kg" fill={colors.primary} />
          &lt;Bar
            yAxisId="calories"
            name="Calories brûlées (kCal)"
            dataKey="calories"
            unit="kCal"
            fill={colors.secondary}
          />
        &lt;/BarChart>
      &lt;/ResponsiveContainer>
      &lt;ChartTitle>Activité quotidienne&lt;/ChartTitle>
    &lt;/Container>
  );
};

export default Activity;
</code></pre>
        </article>
    </section>




</div>

<nav>
    <h2><a href="index.html">Home</a></h2><h3>Global</h3><ul><li><a href="global.html#Activity">Activity</a></li><li><a href="global.html#AverageSessions">AverageSessions</a></li><li><a href="global.html#Header">Header</a></li><li><a href="global.html#KeyFigureCard">KeyFigureCard</a></li><li><a href="global.html#Performance">Performance</a></li><li><a href="global.html#ProfileBody">ProfileBody</a></li><li><a href="global.html#ProfileBodyGraphics">ProfileBodyGraphics</a></li><li><a href="global.html#ProfileBodyKeys">ProfileBodyKeys</a></li><li><a href="global.html#ProfileHeading">ProfileHeading</a></li><li><a href="global.html#Score">Score</a></li><li><a href="global.html#SideBar">SideBar</a></li></ul>
</nav>

<br class="clear">

<footer>
    Documentation generated by <a href="https://github.com/jsdoc/jsdoc">JSDoc 3.6.7</a> on Fri Aug 20 2021 11:51:37 GMT+0200 (heure d’été d’Europe centrale)
</footer>

<script> prettyPrint(); </script>
<script src="scripts/linenumber.js"> </script>
</body>
</html>
